#include <stdio.h>

int nChooseK(int n, int k){
	long long ret = 1, i;
	for (i=0; i<k; i++)
		ret = ret * (n-i) / (i+1);
	return (int) ret;
}

int main(){
	char s[101];
	int n;

	while (scanf("%d %s",&n,s)!=EOF){
		int G=0,B=0,F=0,S=0,i;

		for (i=0; s[i]; i++){
			if (s[i]=='B') B++;
			else if (s[i]=='F') F++;
			else S++;

			if (B==F && B==S) G++;
		}
		
		if (B!=F || B!=S || G<n)
			puts("Impossible");
		else
			printf("%d\n",nChooseK(G-1,n-1));
	}
}
